library libBeRoXM;
{$ifdef fpc}
 {$mode delphi}
{$endif}

uses
  SysUtils,
  jni in 'jni.pas',
  log in 'log.pas',
  BeRoXM in 'BeRoXM.pas';

var BeRoXMInstance:TBeRoXM;
    Position:int64;

procedure Java_com_bero_multimedia_beroxm_BeRoXM_nativeInit(Env:PJNIEnv;this:JObject);{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 Log.__android_log_write(Log.ANDROID_LOG_DEBUG,'libBeRoXM','Entering nativeInit . . .');
 BeRoXMInstance:=TBeRoXM.Create(44100,4096,2,true,0,16,0);
 BeRoXMInstance.ResamplingMethod:=BeRoXMMixerCubicSpline;
 Position:=0;
 Log.__android_log_write(Log.ANDROID_LOG_DEBUG,'libBeRoXM','Leaving nativeInit . . .');
end;

procedure Java_com_bero_multimedia_beroxm_BeRoXM_nativeDone(Env:PJNIEnv;this:JObject);{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 Log.__android_log_write(Log.ANDROID_LOG_DEBUG,'libBeRoXM','Entering nativeDone . . .');
 BeRoXMInstance.Destroy;
 Log.__android_log_write(Log.ANDROID_LOG_DEBUG,'libBeRoXM','Leaving nativeDone . . .');
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeLoad(Env:PJNIEnv;this:JObject;FileName:JString):JBoolean;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
var cFileName:PChar;
    sFileName:string;
begin
 Log.__android_log_write(Log.ANDROID_LOG_DEBUG,'libBeRoXM','Entering nativeLoad . . .');
 cFileName:=Env^.GetStringUTFChars(Env,FileName,nil);
 sFileName:=cFileName;
 Env^.ReleaseStringUTFChars(Env,cFileName,cFileName);
 try
  if BeRoXMInstance.Module.LoadFile(sFileName) then begin
   result:=JNI_TRUE;
  end else begin
   result:=JNI_FALSE;
  end;
 finally
  sFileName:='';
 end;
 Log.__android_log_write(Log.ANDROID_LOG_DEBUG,'libBeRoXM','Leaving nativeLoad . . .');
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetTitle(Env:PJNIEnv;this:JObject):JString;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 result:=env^.NewStringUTF(Env,pchar(BeRoXMInstance.Module.Name));
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetDuration(Env:PJNIEnv;this:JObject):JLong;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 result:=BeRoXMInstance.GetTimeDuration(44100);
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetPosition(Env:PJNIEnv;this:JObject):JLong;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 result:=BeRoXMInstance.OutputSamples;//Position;
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetTrackEnd(Env:PJNIEnv;this:JObject):JBoolean;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 if BeRoXMInstance.Module.TrackEnd then begin
  result:=JNI_TRUE;
 end else begin
  result:=JNI_FALSE;
 end;
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeSeek(Env:PJNIEnv;this:JObject;ToTimePosition:JLong):JLong;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 result:=BeRoXMInstance.SeekToTimePosition(44100,ToTimePosition);
 ResetRingBuffer(BeRoXMInstance.RingBuffer);
 Position:=result;
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativePlay(Env:PJNIEnv;this:JObject):JBoolean;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 BeRoXMInstance.Module.Reset;
 if BeRoXMInstance.Play then begin
  result:=JNI_TRUE;
 end else begin
  result:=JNI_FALSE;
 end;
 ResetRingBuffer(BeRoXMInstance.RingBuffer);
 Position:=0;
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeStop(Env:PJNIEnv;this:JObject):JBoolean;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 BeRoXMInstance.Stop;
 result:=JNI_TRUE;
end;

function Java_com_bero_multimedia_beroxm_BeRoXM_nativeFillBuffer(Env:PJNIEnv;this:JObject;Buffer:JObject;Bytes:JInt):JInt;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
{$ifdef unix}
 BeRoXMInstance.GetBuffer(Env^.GetDirectBufferAddress(Env,Buffer),Bytes);
 result:=Bytes;
{$else}
 result:=0;
{$endif}
 inc(Position,result div 4);
end;

procedure Java_com_bero_multimedia_beroxm_BeRoXM_nativeSetLooping(Env:PJNIEnv;this:JObject;Looping:JBoolean);{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
 BeRoXMInstance.Looping:=Looping<>JNI_FALSE;
end;


exports Java_com_bero_multimedia_beroxm_BeRoXM_nativeInit name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeInit',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeDone name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeDone',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeLoad name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeLoad',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetTitle name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetTitle',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetDuration name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetDuration',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetPosition name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetPosition',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetTrackEnd name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeGetTrackEnd',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeSeek name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeSeek',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativePlay name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativePlay',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeStop name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeStop',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeFillBuffer name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeFillBuffer',
        Java_com_bero_multimedia_beroxm_BeRoXM_nativeSetLooping name 'Java_com_bero_multimedia_beroxm_BeRoXM_nativeSetLooping';

begin
end.
